<?php
class InitialMigration extends CakeMigration {

/**
 * Migration description
 *
 * @var string
 */
	public $description = '';

/**
 * Actions to be performed
 *
 * @var array $migration
 */
	public $migration = array(
		'up' => array(
			'create_table' => array(
				'ev_checkout_customer_addresses' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'user_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'index'),
					'address_line_1' => array('type' => 'string', 'null' => false, 'default' => null, 'length' => 100, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'address_line_2' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 100, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'address_line_3' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 100, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'city' => array('type' => 'string', 'null' => false, 'default' => null, 'length' => 50, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'county' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 50, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'postcode' => array('type' => 'string', 'null' => false, 'default' => null, 'length' => 15, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'is_active' => array('type' => 'boolean', 'null' => false, 'default' => '1'),
					'last_used_for_invoice' => array('type' => 'datetime', 'null' => false, 'default' => null),
					'last_used_for_delivery' => array('type' => 'datetime', 'null' => false, 'default' => null),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => 1),
						'shop_addresses_users1_idx' => array('column' => 'user_id', 'unique' => 0),
					),
					'tableParameters' => array('charset' => 'utf8', 'collate' => 'utf8_general_ci', 'engine' => 'InnoDB'),
				),
				'ev_checkout_order_items' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'order_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'model' => array('type' => 'string', 'null' => false, 'default' => null, 'length' => 250, 'collate' => 'latin1_swedish_ci', 'charset' => 'latin1'),
					'model_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'vat_rate_id' => array('type' => 'integer', 'null' => true, 'default' => null),
					'name' => array('type' => 'string', 'null' => false, 'default' => null, 'length' => 250, 'collate' => 'latin1_swedish_ci', 'charset' => 'latin1'),
					'description' => array('type' => 'string', 'null' => false, 'default' => null, 'length' => 250, 'collate' => 'latin1_swedish_ci', 'charset' => 'latin1'),
					'unit_cost' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'quantity' => array('type' => 'integer', 'null' => false, 'default' => null),
					'subtotal' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'vat' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'total' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'is_virtual' => array('type' => 'boolean', 'null' => false, 'default' => null),
					'modified' => array('type' => 'datetime', 'null' => false, 'default' => null),
					'created' => array('type' => 'datetime', 'null' => false, 'default' => null),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => 1),
					),
					'tableParameters' => array('charset' => 'latin1', 'collate' => 'latin1_swedish_ci', 'engine' => 'MyISAM'),
				),
				'ev_checkout_order_statuses' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'name' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 250, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'system_name' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 45, 'collate' => 'utf8_general_ci', 'comment' => 'Used for firing internal events e.g. shipped -> Model.Order.orderShipped', 'charset' => 'utf8'),
					'created' => array('type' => 'datetime', 'null' => true, 'default' => null),
					'modified' => array('type' => 'datetime', 'null' => true, 'default' => null),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => 1),
					),
					'tableParameters' => array('charset' => 'utf8', 'collate' => 'utf8_general_ci', 'engine' => 'InnoDB'),
				),
				'ev_checkout_orders' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'created' => array('type' => 'datetime', 'null' => false, 'default' => null),
					'modified' => array('type' => 'datetime', 'null' => false, 'default' => null),
					'order_time' => array('type' => 'datetime', 'null' => false, 'default' => null),
					'user_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'delivery_address_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'invoice_address_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'order_status_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'subtotal' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'delivery_cost' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'delivery_surcharge' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '6,2'),
					'vat' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'total' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'items_total' => array('type' => 'integer', 'null' => false, 'default' => null),
					'is_virtual' => array('type' => 'boolean', 'null' => false, 'default' => null),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => 1),
					),
					'tableParameters' => array('charset' => 'utf8', 'collate' => 'utf8_general_ci', 'engine' => 'MyISAM'),
				),
				'ev_checkout_vat_rates' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'rate' => array('type' => 'float', 'null' => true, 'default' => null),
					'name' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 250, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'is_active' => array('type' => 'boolean', 'null' => true, 'default' => null),
					'created' => array('type' => 'datetime', 'null' => true, 'default' => null),
					'modified' => array('type' => 'datetime', 'null' => true, 'default' => null),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => 1),
					),
					'tableParameters' => array('charset' => 'utf8', 'collate' => 'utf8_general_ci', 'engine' => 'InnoDB'),
				)
			),
			'create_field' => array(
				'users' => array(
					'first_name' => array('after' => 'user_group_id', 'type' => 'string', 'null' => true, 'default' => null, 'length' => 45, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'last_name' => array('after' => 'first_name', 'type' => 'string', 'null' => true, 'default' => null, 'length' => 45, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'phone' => array('after' => 'last_name', 'type' => 'string', 'null' => true, 'default' => null, 'length' => 45, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'is_guest_user' => array('after' => 'user_group_id', 'type' => 'boolean', 'null' => false, 'default' => '0', 'key' => 'primary'),
				)
			)
		),
		'down' => array(
			'drop_table' => array(
				'ev_checkout_customer_addresses', 'ev_checkout_order_items', 'ev_checkout_order_statuses', 'ev_checkout_orders', 'ev_checkout_vat_rates'
			),
			'drop_field' => array(
				'users' => array(
				    'first_name',
				    'last_name',
				    'phone',
				    'is_guest_user'
				)
			)
		),
	);

/**
 * Before migration callback
 *
 * @param string $direction, up or down direction of migration process
 * @return boolean Should process continue
 */
	public function before($direction) {
		return true;
	}

/**
 * After migration callback
 *
 * @param string $direction, up or down direction of migration process
 * @return boolean Should process continue
 */
	public function after($direction) {

		if($direction == 'up') {

			$VatRate = ClassRegistry::init('EvCheckout.VatRate');
			$OrderStatus = ClassRegistry::init('EvCheckout.OrderStatus');

			$vatRateData = array(
				array(
					'id' => 1, 
					'rate' => '20', 
					'name' => 'Standard Rate', 
					'is_active' => 1
				),
				array(
					'id' => 2, 
					'rate' => '0', 
					'name' => 'Nil Rate', 
					'is_active' => 1
				)
			);

			$VatRate->create();
			$VatRate->saveAll($vatRateData);

			$orderStatusData = array(
				array(
					'id' => 1, 
					'name' => 'In basket', 
					'system_name' => 'Created', 
				),
				array(
					'id' => 2, 
					'name' => 'Pending', 
					'system_name' => 'Pending', 
				),
				array(
					'id' => 3, 
					'name' => 'Paid', 
					'system_name' => 'Paid', 
				),
				array(
					'id' => 4, 
					'name' => 'Cancelled', 
					'system_name' => 'Cancelled', 
				),
				array(
					'id' => 5, 
					'name' => 'Completed', 
					'system_name' => 'Completed', 
				),
			);

			$OrderStatus->create();
			$OrderStatus->saveAll($orderStatusData);

		}

		return true;
	}
}
